    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.renderer;
    034
    035import java.io.Serializable;
    036import org.jfree.chart3d.data.Range;
    037import org.jfree.chart3d.internal.Args;
    038
    039/**
    040 * An abstract class from which a {@link ColorScale} implementation can be
    041 * derived.
    042 * <br><br>
    043 * NOTE: This class is serializable, but the serialization format is subject
    044 * to change in future releases and should not be relied upon for persisting
    045 * instances of this class.
    046 *
    047 * @since 1.1
    048 */
    049@SuppressWarnings("serial")
    050public abstract class AbstractColorScale implements Serializable {
    051
    052    /** The data value range for the scale. */
    053    private Range range;
    054
    055    /**
    056     * Creates a new color scale for the specified data value range.
    057     *
    058     * @param range  the data value range ({@code null} not permitted).
    059     */
    060    protected AbstractColorScale(Range range) {
    061        Args.nullNotPermitted(range, "range");
    062        this.range = range;
    063    }
    064
    065    /**
    066     * Returns the range of data values over which the scale is defined.  This
    067     * is specified via the constructor and once set cannot be changed.
    068     *
    069     * @return The range (never {@code null}).
    070     */
    071    public Range getRange() {
    072        return this.range;
    073    }
    074
    075    /**
    076     * Tests this color scale for equality with an arbitrary object.
    077     *
    078     * @param obj  the object ({@code null} permitted).
    079     *
    080     * @return A boolean.
    081     */
    082    @Override
    083    public boolean equals(Object obj) {
    084        if (obj == this) {
    085            return true;
    086        }
    087        if (!(obj instanceof AbstractColorScale)) {
    088            return false;
    089        }
    090        AbstractColorScale that = (AbstractColorScale) obj;
    091        if (!this.range.equals(that.range)) {
    092            return false;
    093        }
    094        return true;
    095    }
    096
    097}